"use strict";
const Config = {
    name: "Xpresser",
    env: "development",
    debug: {
        enabled: true,
        requests: {
            enabled: true,
            colored: true,
            showAll: true,
            show: {
                time: false,
                statusCode: true,
                statusMessage: false
            },
            ignore: []
        },
        deprecationWarnings: {
            enabled: true,
            showStack: false
        },
    },
    log: {
        plugins: true,
        serverDomainAndPort: false,
    },
    project: {
        fileExtension: ".js",
    },
    server: {
        maintenanceMiddleware: "MaintenanceMiddleware.js",
        port: 2000,
        protocol: "http",
        domain: "localhost",
        root: "/",
        includePortInUrl: true,
        baseUrl: "",
        ssl: {
            enabled: false,
            port: 443,
        },
        poweredBy: true,
        servePublicFolder: true,
        use: {
            bodyParser: true,
            flash: false,
        },
        requestEngine: {
            dataKey: 'data',
            proceedKey: 'proceed',
            messageKey: '_say'
        },
        router: {
            pathCase: "snake"
        },
    },
    date: {
        timezone: null,
        format: "YYYY-MM-DD H:mm:ss",
    },
    paths: {
        base: __dirname,
        backend: "base://backend",
        frontend: "frontend",
        public: "public",
        storage: "storage",
        xjs: "xjs",
        npm: "base://node_modules",
        routesFile: "backend://routes.js",
        events: "backend://events",
        controllers: "backend://controllers",
        models: "backend://models",
        middlewares: "backend://middlewares",
        views: "backend://views",
        jsonConfigs: "backend://",
        configs: "backend://configs"
    },
    template: {
        use: false,
        engine: "ejs",
        extension: "ejs",
        locals: {
            all: true,
            query: false,
            body: false,
            stackedScripts: false,
        },
    },
    response: {
        cacheFiles: false,
        cacheFileExtensions: ["js", "css"],
        cacheIfMatch: [],
        cacheMaxAge: 31536000,
        overrideServerName: true,
    },
    artisan: {
        loadEvents: false,
        singleModelName: true,
        pluralizeModelTable: true,
        factory: {}
    },
    packages: {},
    plugins: {},
};
const Options = {
    requireOnly: false,
    autoBoot: false,
    isConsole: false,
    isTinker: false,
    exposeDollarSign: true,
    instanceId: undefined,
    isFromXjsCli: false,
};
module.exports = { Config, Options };
