"use strict";
const index_1 = require("../../index");
const child_process_1 = require("child_process");
const $ = (0, index_1.getInstance)();
class JobHelper {
    constructor(name) {
        this.name = null;
        if (name)
            this.name = name;
        this.$ = $;
    }
    isFromXjsCli() {
        return $.options.isFromXjsCli;
    }
    end(silent = false) {
        if (!silent) {
            $.log(`Job: (${this.name}) ran at: ${$.helpers.now()}`);
        }
        return $.exit();
    }
    static dispatch(job, args = []) {
        setTimeout(() => {
            process.nextTick(() => {
                const showLog = $.config.get("env") === "development";
                const base = $.engineData.get("tsBaseFolder", $.path.base());
                const mainModule = require.main.filename.replace(base, "");
                const app = $.isTypescript() ? "npx ts-node" : "node";
                const command = `cd ${base} && ${app} .${mainModule} cli @${job} ${args.join(" ")}`.trim();
                (0, child_process_1.exec)(command, (err, stdout) => {
                    if (showLog) {
                        if (err)
                            console.error(err);
                        else
                            console.log((stdout || "").trim());
                    }
                });
            });
        }, 1000);
    }
}
module.exports = JobHelper;
