"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
const events_1 = __importDefault(require("events"));
const index_1 = require("../../index");
const $ = (0, index_1.getInstance)();
module.exports = (DefinedEvents) => {
    const EventEmitter = new events_1.default.EventEmitter();
    EventEmitter.on("runEvent", async ($payload) => {
        if (DefinedEvents.hasOwnProperty($payload.event)) {
            try {
                if ($payload.callback) {
                    let eventResult;
                    if ($payload.payload) {
                        eventResult = await DefinedEvents[$payload.event](...$payload.payload);
                    }
                    else {
                        eventResult = await DefinedEvents[$payload.event]();
                    }
                    $payload.callback(eventResult);
                }
                else {
                    if ($payload.payload) {
                        DefinedEvents[$payload.event](...$payload.payload);
                    }
                    else {
                        DefinedEvents[$payload.event]();
                    }
                }
            }
            catch (e) {
                $.logError(e);
            }
        }
    });
    return class XpresserEventsEmitter {
        static emit(event, ...args) {
            EventEmitter.emit("runEvent", {
                event,
                payload: args,
            });
        }
        static emitAfter(time = 3000, event, ...args) {
            setTimeout(() => {
                XpresserEventsEmitter.emit(event, ...args);
            }, time);
        }
        static emitWithCallback(event, args, callback) {
            EventEmitter.emit("runEvent", {
                event,
                payload: args,
                callback,
            });
        }
        static define(event, run) {
            DefinedEvents[event] = run;
        }
    };
};
