"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.runBootEvent = void 0;
const index_1 = require("../../index");
const runBootEvent = (name, done) => {
    const $ = (0, index_1.getInstance)();
    const key = `on.${name}`;
    const onEvents = $.on.events()[name];
    if (onEvents.length) {
        onEvents.push(done);
        $.engineData.set(key, 0);
        const next = () => {
            const currentIndex = $.engineData.get(key, 0);
            const nextIndex = currentIndex + 1;
            $.engineData.set(key, nextIndex);
            if (typeof onEvents[nextIndex] === "function") {
                return index_1.InXpresserError.tryOrCatch(() => onEvents[nextIndex](next, $));
            }
        };
        return index_1.InXpresserError.tryOrCatch(() => onEvents[0](next, $));
    }
    else {
        return done ? done() : false;
    }
};
exports.runBootEvent = runBootEvent;
