"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.touchMyMustache = exports.getAllFiles = exports.randomStr = exports.getLocalExternalIp = void 0;
const os_1 = __importDefault(require("os"));
const fs_1 = __importDefault(require("fs"));
const getLocalExternalIp = () => {
    var _a;
    const values = Object.values(os_1.default.networkInterfaces());
    return (_a = [].concat(...values)
        .find((details) => details.family === 'IPv4' && !details.internal)) === null || _a === void 0 ? void 0 : _a.address;
};
exports.getLocalExternalIp = getLocalExternalIp;
const randomStr = (length) => {
    let result = '';
    const characters = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789';
    const charactersLength = characters.length;
    for (let i = 0; i < length; i++) {
        result += characters.charAt(Math.floor(Math.random() * charactersLength));
    }
    return result;
};
exports.randomStr = randomStr;
const getAllFiles = (path) => {
    const list = [];
    if (fs_1.default.existsSync(path)) {
        const files = fs_1.default.readdirSync(path);
        for (const file of files) {
            const fullPath = path + '/' + file;
            if (fs_1.default.lstatSync(fullPath).isDirectory()) {
                const folderFiles = (0, exports.getAllFiles)(fullPath);
                for (const folderFile of folderFiles) {
                    list.push(folderFile);
                }
            }
            else {
                list.push(fullPath);
            }
        }
    }
    return list;
};
exports.getAllFiles = getAllFiles;
function touchMyMustache(str) {
    if (str.indexOf('{{') < 0)
        return [];
    const match = str.match(new RegExp(/{{(.*?)}}/, 'g'));
    return match ? match : [];
}
exports.touchMyMustache = touchMyMustache;
