"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.compareVersion = exports.convertPluginArrayToObject = exports.pluginPathExistOrExit = void 0;
const index_1 = require("../../index");
const $ = (0, index_1.getInstance)();
function pluginPathExistOrExit(plugin, pluginPath, file) {
    const ResolvedRoutePath = $.path.resolve(file, false);
    if (file === ResolvedRoutePath) {
        file = pluginPath + "/" + file;
    }
    else {
        file = ResolvedRoutePath;
    }
    if (!$.file.exists(file)) {
        return $.logPerLine([
            { error: plugin },
            { error: `REQUIRED FILE or DIR MISSING: ${file}` },
            { errorAndExit: "" },
        ], true);
    }
    return file;
}
exports.pluginPathExistOrExit = pluginPathExistOrExit;
function convertPluginArrayToObject(plugins) {
    if (!plugins)
        return {};
    const newPluginsObject = {};
    plugins.map(plugin => newPluginsObject[plugin] = true);
    return newPluginsObject;
}
exports.convertPluginArrayToObject = convertPluginArrayToObject;
function compareVersion(version1, version2) {
    const v1 = version1.split('.');
    const v2 = version2.split('.');
    const k = Math.min(v1.length, v2.length);
    for (let i = 0; i < k; ++i) {
        v1[i] = parseInt(v1[i], 10);
        v2[i] = parseInt(v2[i], 10);
        if (v1[i] > v2[i])
            return 1;
        if (v1[i] < v2[i])
            return -1;
    }
    return v1.length == v2.length ? 0 : (v1.length < v2.length ? -1 : 1);
}
exports.compareVersion = compareVersion;
