"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.pathToUrl = void 0;
const path_to_regexp_1 = require("path-to-regexp");
function pathToUrl(path) {
    if (typeof path !== "string")
        return path;
    try {
        const segments = (0, path_to_regexp_1.parse)(path);
        const newUrl = [];
        for (const segment of segments) {
            if (typeof segment === "string") {
                newUrl.push(segment);
            }
            else {
                newUrl.push(segment.prefix + "_??_");
            }
        }
        return newUrl.join("");
    }
    catch {
        return path;
    }
}
exports.pathToUrl = pathToUrl;
