"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ifOrElse = exports.ifNotDefined = exports.isNullOrUndefined = void 0;
function isNullOrUndefined(item) {
    return item === null || item === undefined;
}
exports.isNullOrUndefined = isNullOrUndefined;
function ifNotDefined(variable, alt) {
    if (typeof variable === "function") {
        variable = variable();
    }
    if (isNullOrUndefined(variable) && typeof alt === "function") {
        alt = alt();
    }
    return (isNullOrUndefined(variable) ? alt : variable);
}
exports.ifNotDefined = ifNotDefined;
function ifOrElse(variable, alt) {
    if (typeof variable === "function") {
        variable = variable();
    }
    if (!variable && typeof alt === "function") {
        alt = alt();
    }
    return (variable ? variable : alt);
}
exports.ifOrElse = ifOrElse;
