"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class StringHelper {
    static upperFirst(str) {
        return str[0].toUpperCase() + str.substring(1);
    }
    static lowerFirst(str) {
        return str[0].toLowerCase() + str.substring(1);
    }
    static hasSuffix(str, suffix) {
        return str.slice(-suffix.length) === suffix;
    }
    static withSuffix(str, suffix) {
        if (!this.hasSuffix(str, suffix)) {
            str += suffix;
        }
        return str;
    }
    static withoutSuffix(str, suffix) {
        if (this.hasSuffix(str, suffix)) {
            str = str.substring(0, str.length - suffix.length);
        }
        return str;
    }
}
exports.default = StringHelper;
