"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const index_1 = require("../index");
const $ = (0, index_1.getInstance)();
const OnEvents = {
    start: [],
    boot: [],
    expressInit: [],
    bootServer: [],
    http: [],
    https: [],
    serverBooted: []
};
const AddToEvents = (name, todo) => {
    if (Array.isArray(todo)) {
        for (const key in todo) {
            if (todo.hasOwnProperty(key)) {
                $.on[name](todo[key]);
            }
        }
    }
    else {
        OnEvents[name].push(todo);
    }
};
$.on = {
    events() {
        return OnEvents;
    },
    start(todo) {
        return AddToEvents("start", todo);
    },
    boot(todo) {
        return AddToEvents("boot", todo);
    },
    expressInit(todo) {
        return AddToEvents("expressInit", todo);
    },
    bootServer(todo) {
        return AddToEvents("bootServer", todo);
    },
    http(todo) {
        return AddToEvents("http", todo);
    },
    https(todo) {
        return AddToEvents("https", todo);
    },
    serverBooted(todo) {
        return AddToEvents("serverBooted", todo);
    },
};
