"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
const RequestEngine_1 = __importDefault(require("../RequestEngine"));
const index_1 = require("../../index");
const Path_1 = __importDefault(require("../Helpers/Path"));
const $ = (0, index_1.getInstance)();
let ExtendedRequestEngine = RequestEngine_1.default;
$.engineData.set("ExtendedRequestEngine", () => ExtendedRequestEngine);
$.extendedRequestEngine = () => {
    return $.engineData.get("ExtendedRequestEngine")();
};
const PluginNameSpaces = $.engineData.get("PluginEngine:namespaces", {});
const useDotJson = $.engineData.get("UseDotJson");
const ExtendRequestEngineUsing = (extender) => {
    if (typeof extender === "function") {
        if (typeof extender.expressify === "function") {
            ExtendedRequestEngine = extender;
        }
        else {
            ExtendedRequestEngine = extender(ExtendedRequestEngine);
        }
    }
    else {
        throw new Error("Custom RequestEngine extender must be a function or an extended RequestEngine class.");
    }
};
const RequireOrFail = ($RequestEngine, plugin) => {
    try {
        $RequestEngine = Path_1.default.resolve($RequestEngine);
        ExtendRequestEngineUsing(require($RequestEngine));
    }
    catch (e) {
        $.logPerLine([
            plugin === undefined ? {} : { error: `Error in plugin: ${plugin}` },
            { error: e.stack },
            { errorAndExit: "" },
        ]);
    }
};
const pluginNamespaceKeys = Object.keys(PluginNameSpaces);
for (let k = 0; k < pluginNamespaceKeys.length; k++) {
    const pluginNamespaceKey = pluginNamespaceKeys[k];
    const plugin = $.objectCollection(PluginNameSpaces[pluginNamespaceKey]);
    if (plugin.has("extends.RequestEngine")) {
        const requestEngineExtender = plugin.get("extends.RequestEngine");
        RequireOrFail(requestEngineExtender, pluginNamespaceKey);
    }
}
const userRequestExtension = useDotJson.get("extends.RequestEngine", false);
if (userRequestExtension) {
    if (Array.isArray(userRequestExtension)) {
        for (const extension of userRequestExtension) {
            RequireOrFail(extension);
        }
    }
    else {
        RequireOrFail(userRequestExtension);
    }
}
module.exports = ExtendedRequestEngine;
