"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const fs_1 = __importDefault(require("fs"));
const index_1 = require("../../index");
const RouterEngine_1 = __importDefault(require("../RouterEngine"));
const Path_1 = __importDefault(require("../Helpers/Path"));
const $ = (0, index_1.getInstance)();
$.routerEngine = RouterEngine_1.default;
const RouteFile = Path_1.default.resolve($.config.get('paths.routesFile'));
if (fs_1.default.existsSync(RouteFile)) {
    try {
        require(RouteFile);
    }
    catch (e) {
        $.logPerLine([
            { error: "Router Error:" },
            { errorAndExit: e },
        ]);
    }
}
const PluginData = $.engineData.get("PluginEngineData");
const PluginRoutes = PluginData.routes;
for (let i = 0; i < PluginRoutes.length; i++) {
    const pluginRoute = PluginRoutes[i];
    const Routes = require(pluginRoute.path);
    if (typeof Routes === "object" &&
        (Routes.constructor && Routes.constructor.name === "XpresserRouter")) {
        $.routerEngine.addToRoutes(Routes);
    }
}
if (typeof $.router.routesAfterPlugins === "function") {
    $.router.routesAfterPlugins();
}
